workflow:
  rules:
    - if: $CI_COMMIT_BRANCH != "main" && $CI_PIPELINE_SOURCE != "merge_request_event"
      when: never
    - when: always

stages:
  - test
  - build
  - deploy

run_unit_tests:
  stage: test
  before_script:
    - echo "Preparing test data..."

  script:
    - echo "Running unit tests..."
  after_script:
    - echo "Cleaning up temporary files..."
    
run_lint_tests:
  stage: test
  before_script:
    - echo "Preparing test data..."
  script:
    - echo "Running lint tests..."
  after_script:
    - echo "Cleaning up temporary files..."

build_image:
  only:
    - main
  stage: build
  script:
    - echo "Building the docker image..."
    - echo "Tagging the docker image"

push_image:
  only:
    - main
  stage: build
  needs:
    - build_image
  script:
    - echo "Logging into docker registry..."
    - echo "Pushing docker image to registry..."

deploy_image:
  only:
    - main
  stage: deploy
  needs:
    - push_image
  script:
    - echo "Deploying new docker image to dev server"
